import React, { Component } from 'react';

import smart3d from 'smart3d';
import './App.css';

class App extends Component {
  constructor(props) {
    super(props);
    this.viewer = undefined;
  }

  componentDidMount() {
    this.viewer = new smart3d.Viewer('container', {
      sceneMode: smart3d.SceneMode.SCENE3D,
      scene3DOnly: true,
      terrainProvider: smart3d.TerrainManager.createWorldTerrain()
    });
    this.measureHandler = undefined;

    window.viewer = this.viewer;
  }

  clearMeasureHandler = () => {
    if (this.measureHandler) {
      this.measureHandler.clear();
    }
  }

  measureDistance = () => {
    this.clearMeasureHandler();
    this.measureHandler = new smart3d.MeasureHandler(this.viewer, smart3d.MeasureMode.Distance);
    this.measureHandler.activate();
  }

  measureDistanceClampedGround = () => {
    this.clearMeasureHandler();
    this.measureHandler = new smart3d.MeasureHandler(this.viewer, smart3d.MeasureMode.Distance, true);
    this.measureHandler.activate();
  }

  render() {
    return (
      <>
        <div id="container">
        </div>
        <div className="button">
          <button onClick={this.measureDistance}>不贴地测量距离</button>
          <button onClick={this.measureDistanceClampedGround}>贴地测量距离</button>
        </div>
      </>
    );
  }
}

export default App;
